#define _GNU_SOURCE
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sched.h>
#include <sys/types.h>

static int move_to_cpu(int cpu)
{
        cpu_set_t set;

        CPU_ZERO(&set);
        CPU_SET(cpu, &set);
        return sched_setaffinity(0, sizeof(set), &set);
}

static void loop(void)
{
        for (;;) ;
}

static int fork_hog(int cpu)
{
        int pid;

        pid = (int) fork();
        if (pid == 0) {
                move_to_cpu(cpu);
                loop();
                exit(0);
        }

        return pid;
}

int main(int argc, char *argv[])
{
        int i, pid, cpu, nr_procs;

		if (argc != 3) {
			printf("usage: hog < nr-procs > < CPU >\n");
			exit(1);
		}

		cpu = atoi(argv[2]);
		nr_procs = atoi(argv[1]);

        for (i = 0; i < nr_procs; i++) {
                pid = fork_hog(cpu);
                fprintf(stderr, "created hog%d pid=%d\n", i, pid);
        }

        fprintf(stderr, "pausing...\n");
        pause();

        return 0;
}
